%{
/* R0, R3-R12 are scratch at a call site, with R3-R10 as register parms.  We 
 * must reserve R1 (SP) and R2 (TOC).  Return value in R3; structure return
 * passes a hidden extra parameter.  We use R0, R11, and R12 for block copies,
 * and R31 for a Frame Pointer (FP).  We intermingle temps & register vars. 
 * Temps from register 31 down to 13 and reg-vars from 31 down to 20.
 */
#define    INTTMP 0x7fffe000
#define    INTVAR 0x7ff00000

/* Float registers 14-31 are preserved across calls, with F1-F13 for arguments.
 * Use registers 14-31 as temps and 20-31 as reg vars.
 */
#define FLTTMP 0xffffc000
#define FLTVAR 0xfff00000

#define readsreg(p) \
	(generic((p)->op)==INDIR && (p)->kids[0]->op==VREG+P)

#define relink(a, b) ((b)->x.prev = (a), (a)->x.next = (b))

#include "c.h"
#define TOC_SEG 5		/* Special Power ABI segment */
#define NODEPTR_TYPE Node
#define OP_LABEL(p) ((p)->op)
#define LEFT_CHILD(p) ((p)->kids[0])
#define RIGHT_CHILD(p) ((p)->kids[1])
#define STATE_LABEL(p) ((p)->x.state)
static void address     ARGS((Symbol, Symbol, int));
static void blkfetch    ARGS((int, int, int, int));
static void blkloop     ARGS((int, int, int, int, int, int[]));
static void blkstore    ARGS((int, int, int, int));
static void defaddress  ARGS((Symbol));
static void defconst    ARGS((int, Value));
static void defstring   ARGS((int, char *));
static void defsymbol   ARGS((Symbol));
static void doarg       ARGS((Node));
static void emit2       ARGS((Node));
static void export      ARGS((Symbol));
static void clobber     ARGS((Node));
static void function    ARGS((Symbol, Symbol [], Symbol [], int));
static void global      ARGS((Symbol));
static void import      ARGS((Symbol));
static void local       ARGS((Symbol));
static void progbeg     ARGS((int, char **));
static void progend     ARGS((void));
static void segment     ARGS((int));
static void space       ARGS((int));
static void target      ARGS((Node));
static int  is_varargs_called ARGS((Node));
extern int  atoi        ARGS((char *));
static int  ff1         ARGS((unsigned));
static int  hibits( Node p );
static int  bitrun( Node p );
static int  bins( Node p );

static Symbol ireg[32], freg2[32];
static int tmpregs[] = {0, 11, 12}; /* Regs for block copies */

static int gnum = 8;

static int cseg = 0;		/* Current segment */
static int pretty_print = 0;	/* Annotate assembler with comments? */

%}
%start stmt
%term ADDD=306 ADDF=305 ADDI=309 ADDP=311 ADDU=310
%term ADDRFP=279
%term ADDRGP=263
%term ADDRLP=295
%term ARGB=41 ARGD=34 ARGF=33 ARGI=37 ARGP=39
%term ASGNB=57 ASGNC=51 ASGND=50 ASGNF=49 ASGNI=53 ASGNP=55 ASGNS=52
%term BANDU=390
%term BCOMU=406
%term BORU=422
%term BXORU=438
%term CALLB=217 CALLD=210 CALLF=209 CALLI=213 CALLV=216
%term CNSTC=19 CNSTD=18 CNSTF=17 CNSTI=21 CNSTP=23 CNSTS=20 CNSTU=22
%term CVCI=85 CVCU=86
%term CVDF=97 CVDI=101
%term CVFD=114
%term CVIC=131 CVID=130 CVIS=132 CVIU=134
%term CVPU=150
%term CVSI=165 CVSU=166
%term CVUC=179 CVUI=181 CVUP=183 CVUS=180
%term DIVD=450 DIVF=449 DIVI=453 DIVU=454
%term EQD=482 EQF=481 EQI=485
%term GED=498 GEF=497 GEI=501 GEU=502
%term GTD=514 GTF=513 GTI=517 GTU=518
%term INDIRB=73 INDIRC=67 INDIRD=66 INDIRF=65 INDIRI=69 INDIRP=71 INDIRS=68
%term JUMPV=584
%term LABELV=600
%term LED=530 LEF=529 LEI=533 LEU=534
%term LOADB=233 LOADC=227 LOADD=226 LOADF=225 LOADI=229 LOADP=231 LOADS=228 LOADU=230
%term LSHI=341 LSHU=342
%term LTD=546 LTF=545 LTI=549 LTU=550
%term MODI=357 MODU=358
%term MULD=466 MULF=465 MULI=469 MULU=470
%term NED=562 NEF=561 NEI=565
%term NEGD=194 NEGF=193 NEGI=197
%term RETD=242 RETF=241 RETI=245
%term RSHI=373 RSHU=374
%term SUBD=322 SUBF=321 SUBI=325 SUBP=327 SUBU=326
%term VREGP=615
%%
reg:  INDIRC(VREGP)     "# read register\n"
reg:  INDIRD(VREGP)     "# read register\n"
reg:  INDIRF(VREGP)     "# read register\n"
reg:  INDIRI(VREGP)     "# read register\n"
reg:  INDIRP(VREGP)     "# read register\n"
reg:  INDIRS(VREGP)     "# read register\n"
stmt: ASGNC(VREGP,reg)  "# write register\n"
stmt: ASGND(VREGP,reg)  "# write register\n"
stmt: ASGNF(VREGP,reg)  "# write register\n"
stmt: ASGNI(VREGP,reg)  "# write register\n"
stmt: ASGNP(VREGP,reg)  "# write register\n"
stmt: ASGNS(VREGP,reg)  "# write register\n"
con: CNSTC  "%a"
con: CNSTI  "%a"
con: CNSTP  "%a"
con: CNSTS  "%a"
con: CNSTU  "%a"
stmt: reg  ""
reg: CVIU(reg)  "%0"  notarget(a)
reg: CVPU(reg)  "%0"  notarget(a)
reg: CVUI(reg)  "%0"  notarget(a)
reg: CVUP(reg)  "%0"  notarget(a)

reg:   ADDRGP  "# toc access\n" 2 /* Requires a full load, very expensive */

con16: CNSTC  "%a"  range(a,-32768,32767)	/* Small integer constants */
con16: CNSTS  "%a"  range(a,-32768,32767)
con16: CNSTI  "%a"  range(a,-32768,32767)
con16: CNSTU  "%a"  range(a,0,32767)
con16: CNSTP  "%a"  range(a,-32768,32767)
reg:   con16  "\taddi \tr%c,r0,%0\n"  1
reg:   con    "\taddis \tr%c,r0,(%a-((%a<16)>16))>16\n\taddi \tr%c,r%c,(%a<16)>16\t# Big constant %a\n" 2

conhi: con    "\taddis \tr%c,r0,(%a-((%a<16)>16))>16\t# Big offset %a \n" 1
addr:  conhi  "((%a<16)>16)(r%0)"

reg:   ADDRFP  "\taddis \tr%c,FP,(%a-((%a<16)>16))>16\n\taddi \tr%c,r%c,(%a<16)>16\t# Big frame offset %a\n" 2
addr:  ADDRFP "%a(FP)"   range(a,-32768+220,32767+220)
reg:   ADDRFP "\taddi \tr%c,FP,%a\n"  range(a,-32768+220,32767+220)

reg:   ADDRLP  "\taddis \tr%c,FP,(%a-((%a<16)>16))>16\n\taddi \tr%c,r%c,(%a<16)>16\t# Big local offset %a\n" 2
addr:  ADDRLP "%a(FP)" range(a,-32768,32767)
reg:   ADDRLP "\taddi \tr%c,FP,%a\n" range(a,-32768,32767)

addr:  con16  "%0(r0)"
addr:  ADDI(reg,con16) "%1(r%0)"
addr:  ADDP(reg,con16) "%1(r%0)"
addr:  ADDU(reg,con16) "%1(r%0)"
addr:  reg             "0(r%0)"
idx:   ADDI(reg,reg)   "r%0,r%1"
idx:   ADDU(reg,reg)   "r%0,r%1"
idx:   ADDP(reg,reg)   "r%0,r%1"

stmt: ASGNC(addr,reg)  "\tstb \tr%1,%0\n"  1
stmt: ASGNS(addr,reg)  "\tsth \tr%1,%0\n"  1
stmt: ASGNI(addr,reg)  "\tstw \tr%1,%0\n"  1
stmt: ASGNP(addr,reg)  "\tstw \tr%1,%0\n"  1
stmt: ASGND(addr,reg)  "\tstfd \tf%1,%0\n" 1
stmt: ASGNF(addr,reg)  "\tstfs \tf%1,%0\n" 1
stmt: ASGNC(idx,reg)   "\tstbx \tr%1,%0\n"  1
stmt: ASGNS(idx,reg)   "\tsthx \tr%1,%0\n"  1
stmt: ASGNI(idx,reg)   "\tstwx \tr%1,%0\n"  1
stmt: ASGNP(idx,reg)   "\tstwx \tr%1,%0\n"  1
stmt: ASGND(idx,reg)   "\tstfdx \tf%1,%0\n" 1
stmt: ASGNF(idx,reg)   "\tstfsx \tf%1,%0\n" 1

reg:  INDIRC(addr)     "\tlbz \tr%c,%0\n"  1
reg:  INDIRS(addr)     "\tlha \tr%c,%0\n"  1
reg:  INDIRI(addr)     "\tlwz \tr%c,%0\n"  1
reg:  INDIRP(addr)     "\tlwz \tr%c,%0\n"  1
reg:  INDIRD(addr)     "\tlfd \tf%c,%0\n"  1
reg:  INDIRF(addr)     "\tlfs \tf%c,%0\n"  1
reg:  INDIRC(idx)      "\tlbzx \tr%c,%0\n"  1
reg:  INDIRS(idx)      "\tlhax \tr%c,%0\n"  1
reg:  INDIRI(idx)      "\tlwzx \tr%c,%0\n"  1
reg:  INDIRP(idx)      "\tlwzx \tr%c,%0\n"  1
reg:  INDIRD(idx)      "\tlfdx \tf%c,%0\n"  1
reg:  INDIRF(idx)      "\tlfsx \tf%c,%0\n"  1

reg:  CVSI(INDIRS(addr))  "\tlha \tr%c,%0\n" 1
reg:  CVCU(INDIRC(addr))  "\tlbz \tr%c,%0\n" 1
reg:  CVSU(INDIRS(addr))  "\tlhz \tr%c,%0\n" 1
reg:  CVSI(INDIRS(idx))  "\tlhax \tr%c,%0\n" 1
reg:  CVCU(INDIRC(idx))  "\tlbzx \tr%c,%0\n" 1
reg:  CVSU(INDIRS(idx))  "\tlhzx \tr%c,%0\n" 1

reg: CVIC(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: CVIS(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: CVIU(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: CVPU(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: CVUC(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: CVUI(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: CVUP(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: CVUS(reg)  "\tmr \tr%c,r%0\n"  move(a)

reg: CVIC(reg)  "%0"  notarget(a)
reg: CVIS(reg)  "%0"  notarget(a)
reg: CVUC(reg)  "%0"  notarget(a)
reg: CVUS(reg)  "%0"  notarget(a)
reg: LOADC(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: LOADI(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: LOADP(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: LOADS(reg)  "\tmr \tr%c,r%0\n"  move(a)
reg: LOADU(reg)  "\tmr \tr%c,r%0\n"  move(a)

reg:  ADDI(reg,reg)   "\tadd  \tr%c,r%0,r%1\n" 1
reg:  ADDI(reg,con16) "\taddi \tr%c,r%0,%1\n"  1
reg:  ADDI(reg,con)   "\taddis \tr%c,r%0,(%1-((%1<16)>16))>16\n\taddi \tr%c,r%c,(%1<16)>16\n"  2
reg:  ADDP(reg,con16) "\taddi \tr%c,r%0,%1\n"  1
reg:  ADDP(reg,reg)   "\tadd  \tr%c,r%0,r%1\n" 1
reg:  ADDU(reg,reg)   "\tadd  \tr%c,r%0,r%1\n" 1
reg:  ADDU(reg,con16) "\taddi \tr%c,r%0,%1\n"  1

mcon16: CNSTC  "%a"  range(a,-32767,32768)	/* Small integer constants */
mcon16: CNSTS  "%a"  range(a,-32767,32768)	/* Small integer constants */
mcon16: CNSTI  "%a"  range(a,-32767,32768)	/* Small integer constants */
mcon16: CNSTU  "%a"  range(a,     0,32768)	/* Small integer constants */
mcon16: CNSTP  "%a"  range(a,-32767,32768)	/* Small integer constants */
reg:  SUBI(reg,reg)    "\tsubf \tr%c,r%1,r%0\n" 1
reg:  SUBI(reg,mcon16) "\taddi \tr%c,r%0,-%1\n" 1
reg:  SUBP(reg,reg)    "\tsubf \tr%c,r%1,r%0\n" 1
reg:  SUBP(reg,mcon16) "\taddi \tr%c,r%0,-%1\n" 1
reg:  SUBU(reg,reg)    "\tsubf \tr%c,r%1,r%0\n" 1
reg:  SUBU(reg,mcon16) "\taddi \tr%c,r%0,-%1\n" 1

lcon16: CNSTC  "%a"  range(a,0,65535)
lcon16: CNSTS  "%a"  range(a,0,65535)
lcon16: CNSTI  "%a"  range(a,0,65535)
lcon16: CNSTU  "%a"  range(a,0,65535)
lcon16: CNSTP  "%a"  range(a,0,65535)
ucon16: CNSTC  "%a"  hibits(a)
ucon16: CNSTS  "%a"  hibits(a)
ucon16: CNSTI  "%a"  hibits(a)
ucon16: CNSTU  "%a"  hibits(a)
ucon16: CNSTP  "%a"  hibits(a)

reg: BCOMU(reg)        "\tnand \tr%c,r%0,r%0\n"   1
reg: BANDU(reg,reg)    "\tand    \tr%c,r%0,r%1\n" 1
reg: BANDU(reg,lcon16) "\tandi.  \tr%c,r%0,%1\n"  1
reg: BANDU(reg,ucon16) "\tandis. \tr%c,r%0,(%1>16)&0xffff\n"  1
reg: BANDU(reg,BCOMU(reg)) "\tandc \tr%c,r%0,r%1\n" 1
reg: BANDU(BCOMU(reg),reg) "\tandc \tr%c,r%1,r%0\n" 1
reg: BCOMU(BANDU(reg,reg)) "\tnand \tr%c,r%0,r%1\n" 1
reg: BCOMU(BANDU(reg,BCOMU(reg))) "\torc \tr%c,r%1,r%0\n"  1
reg: BCOMU(BANDU(BCOMU(reg),reg)) "\torc \tr%c,r%0,r%1\n"  1

reg: BORU(reg,reg)     "\tor   \tr%c,r%0,r%1\n" 1
reg: BORU(reg,lcon16)  "\tori  \tr%c,r%0,%1\n"  1
reg: BORU(reg,ucon16)  "\toris \tr%c,r%0,(%1>16)&0xffff\n"  1
reg: BORU(reg,BCOMU(reg)) "\torc \tr%c,r%0,r%1\n" 1
reg: BORU(BCOMU(reg),reg) "\torc \tr%c,r%1,r%0\n" 1
reg: BCOMU(BORU(reg,reg)) "\tnor \tr%c,r%0,r%1\n" 1
reg: BCOMU(BORU(reg,BCOMU(reg))) "\tandc \tr%c,r%1,r%0\n"  1
reg: BCOMU(BORU(BCOMU(reg),reg)) "\tandc \tr%c,r%0,r%1\n"  1

reg: BORU(reg,con)     "\toris \tr%c,r%0,(%1>16)&0xffff\n\tori \tr%c,r%c,%1&0xffff\n" 2
reg: BXORU(reg,reg)    "\txor  \tr%c,r%0,r%1\n" 1
reg: BXORU(reg,lcon16) "\txori \tr%c,r%0,%1\n"  1
reg: BXORU(reg,ucon16) "\txori \tr%c,r%0,(%1>16)&0xffff\n"  1
reg: BXORU(reg,con)    "\txoris \tr%c,r%0,(%1>16)&0xffff\n\txori \tr%c,r%c,%1&0xffff\n" 2

bitrun: CNSTC  "%a"  bitrun(a)
bitrun: CNSTS  "%a"  bitrun(a)
bitrun: CNSTI  "%a"  bitrun(a)
bitrun: CNSTU  "%a"  bitrun(a)
bitrun: CNSTP  "%a"  bitrun(a)
and_mask: BANDU(reg,bitrun) "%0" (a->x.argno=RIGHT_CHILD(a)->x.argno,0)
reg: and_mask "\trlwinm \tr%c,r%0,0,%B\t\t# And r%0 with mask (%B) into r%c\n" 1

reg: BORU(and_mask,and_mask) "?\tmr \tr%c,r%0\n \trlwimi \tr%c,r%1,0,%B\t\t# (r%1 & %B) | (r%0 & ~%B)\n" bins(a)

reg: DIVI(reg,reg)  "\tdivw  \tr%c,r%0,r%1\n" 1
reg: DIVU(reg,reg)  "\tdivwu \tr%c,r%0,r%1\n" 1
reg: MODI(reg,reg)  "\tdivw \tr0,r%0,r%1\t\t# Divide and truncate\n\tmullw \tr0,r0,r%1\t\t# Multiply back, rounded\n\tsubf \tr%c,r0,r%0\t\t# Compute signed remainder\n" 3
reg: MODU(reg,reg)  "\tdivwu \tr0,r%0,r%1\t\t# Divide and truncate\n\tmullw \tr0,r0,r%1\t\t# Multiply back, rounded\n\tsubf \tr%c,r0,r%0\t\t# Compute unsigned remainder\n" 3
reg: MULI(reg,reg)  "\tmullw \tr%c,r%0,r%1\n" 1
reg: MULU(reg,reg)  "\tmullw \tr%c,r%0,r%1\n" 1

con5: CNSTC          "%a"   range(a,0,31)
con5: CNSTS          "%a"   range(a,0,31)
con5: CNSTI          "%a"   range(a,0,31)
con5: CNSTU          "%a"   range(a,0,31)
reg: LSHI(reg,con5) "\trlwinm \tr%c,r%0,%1,0,31-%1\t# left shift r%0 by %1 into r%c\n"  1
reg: LSHU(reg,con5) "\trlwinm \tr%c,r%0,%1,0,31-%1\t# left shift r%0 by %1 into r%c\n"  1
reg: RSHI(reg,con5) "\tsrawi \tr%c,r%0,%1\t\t# Shift right arithmetic by %1\n"  1
reg: RSHU(reg,con5) "\trlwinm \tr%c,r%0,32-%1,%1,31\t# Shift right logical r%0 by %1 into r%c\n"  1
reg: LSHI(reg,reg)  "\tslw \tr%c,r%0,r%1\t# Shift left logical by r%1\n" 1
reg: LSHU(reg,reg)  "\tslw \tr%c,r%0,r%1\t# Shift left logical by r%1\n" 1
reg: RSHI(reg,reg)  "\tsraw \tr%c,r%0,r%1\t# Shift right arithmetic by r%1\n" 1
reg: RSHU(reg,reg)  "\tsrw \tr%c,r%0,r%1\t# Shift right logical by r%1\n"  1

reg: NEGI(reg)   "\tneg \tr%c,r%0\n"  1
reg: LOADC(reg)  "\tmr\tr%c,r%0\n"  move(a)
reg: LOADS(reg)  "\tmr\tr%c,r%0\n"  move(a)
reg: LOADI(reg)  "\tmr\tr%c,r%0\n"  move(a)
reg: LOADP(reg)  "\tmr\tr%c,r%0\n"  move(a)
reg: LOADU(reg)  "\tmr\tr%c,r%0\n"  move(a)
reg: LOADD(reg)  "\tfmr\tf%c,f%0\n" move(a)
reg: LOADF(reg)  "\tfmr\tf%c,f%0\n" move(a)
reg: ADDD(reg,reg)  "\tfadd  \tf%c,f%0,f%1\n"  1
reg: ADDF(reg,reg)  "\tfadds \tf%c,f%0,f%1\n"  1
reg: DIVD(reg,reg)  "\tfdiv  \tf%c,f%0,f%1\n"  1
reg: DIVF(reg,reg)  "\tfdivs \tf%c,f%0,f%1\n"  1
reg: MULD(reg,reg)  "\tfmul  \tf%c,f%0,f%1\n"  1
reg: MULF(reg,reg)  "\tfmuls \tf%c,f%0,f%1\n"  1
reg: SUBD(reg,reg)  "\tfsub  \tf%c,f%0,f%1\n"  1
reg: SUBF(reg,reg)  "\tfsubs \tf%c,f%0,f%1\n"  1
reg: NEGD(reg)      "\tfneg  \tf%c,f%0\n"      1
reg: NEGF(reg)      "\tfneg  \tf%c,f%0\n"      1
reg: CVCI(reg)  "\textsb \tr%c,r%0\n"      1
reg: CVCI(reg)  "\textsb \tr%c,r%0\n"      1
reg: CVSI(reg)  "\textsh \tr%c,r%0\n"      1
reg: CVCU(reg)  "\tandi. \tr%c,r%0,0xff\n"   1
reg: CVSU(reg)  "\tandi. \tr%c,r%0,0xffff\n" 1
reg: CVDF(reg)  "\tfmr \tf%c,f%0\n"  move(a)
reg: CVFD(reg)  "\tfmr \tf%c,f%0\n"  move(a)
reg: CVID(reg)  "# Int to double\n" 8
reg: CVDI(reg)  "# Double to int\n" 3

stmt: EQI(reg,reg)    "\tcmp   \tCR0,0,r%0,r%1\n\tbeq \t%a\n" 2
stmt: EQI(reg,con16)  "\tcmpi  \tCR0,0,r%0,%1\n \tbeq \t%a\n" 2
stmt: EQI(reg,lcon16) "\tcmpli \tCR0,0,r%0,%1\n \tbeq \t%a\n" 2
stmt: GEI(reg,reg)    "\tcmp   \tCR0,0,r%0,r%1\n\tbge \t%a\n" 2
stmt: GEI(reg,con16)  "\tcmpi  \tCR0,0,r%0,%1\n \tbge \t%a\n" 2
stmt: GEU(reg,reg)    "\tcmpl  \tCR0,0,r%0,r%1\n\tbge \t%a\n" 2
stmt: GEU(reg,lcon16) "\tcmpli \tCR0,0,r%0,%1\n \tbge \t%a\n" 2
stmt: GTI(reg,reg)    "\tcmp   \tCR0,0,r%0,r%1\n\tbgt \t%a\n" 2
stmt: GTI(reg,con16)  "\tcmpi  \tCR0,0,r%0,%1\n \tbgt \t%a\n" 2
stmt: GTU(reg,reg)    "\tcmpl  \tCR0,0,r%0,r%1\n\tbgt \t%a\n" 2
stmt: GTU(reg,lcon16) "\tcmpli \tCR0,0,r%0,%1\n \tbgt \t%a\n" 2
stmt: LEI(reg,reg)    "\tcmp   \tCR0,0,r%0,r%1\n\tble \t%a\n" 2
stmt: LEI(reg,con16)  "\tcmpi  \tCR0,0,r%0,%1\n \tble \t%a\n" 2
stmt: LEU(reg,reg)    "\tcmpl  \tCR0,0,r%0,r%1\n\tble \t%a\n" 2
stmt: LEU(reg,lcon16) "\tcmpli \tCR0,0,r%0,%1\n \tble \t%a\n" 2
stmt: LTI(reg,reg)    "\tcmp   \tCR0,0,r%0,r%1\n\tblt \t%a\n" 2
stmt: LTI(reg,con16)  "\tcmpi  \tCR0,0,r%0,%1\n \tblt \t%a\n" 2
stmt: LTU(reg,reg)    "\tcmpl  \tCR0,0,r%0,r%1\n\tblt \t%a\n" 2
stmt: LTU(reg,lcon16) "\tcmpli \tCR0,0,r%0,%1\n \tblt \t%a\n" 2
stmt: NEI(reg,reg)    "\tcmp   \tCR0,0,r%0,r%1\n\tbne \t%a\n" 2
stmt: NEI(reg,con16)  "\tcmpi  \tCR0,0,r%0,%1\n \tbne \t%a\n" 2
stmt: NEI(reg,lcon16) "\tcmpli \tCR0,0,r%0,%1\n \tbne \t%a\n" 2

zero: CNSTC "%a" range(a,0,0)
zero: CNSTI "%a" range(a,0,0)
zero: CNSTU "%a" range(a,0,0)
zero: CNSTS "%a" range(a,0,0)
zero: CNSTP "%a" range(a,0,0)

stmt: EQI(BANDU(reg,lcon16),zero) "\tandi. \tr0,r%0,%1\n\tbeq \t%a\n" 2
stmt: NEI(BANDU(reg,lcon16),zero) "\tandi. \tr0,r%0,%1\n\tbne \t%a\n" 2
stmt: EQI(CVUI(BANDU(reg,lcon16)),zero) "\tandi. \tr0,r%0,%1\n\tbeq \t%a\n" 2
stmt: NEI(CVUI(BANDU(reg,lcon16)),zero) "\tandi. \tr0,r%0,%1\n\tbne \t%a\n" 2

stmt: EQI(CVCU(reg),zero) "\tandi. \tr0,r%0,0xff\n\tbeq \t%a\n" 2
stmt: NEI(CVCU(reg),zero) "\tandi. \tr0,r%0,0xff\n\tbne \t%a\n" 2
stmt: EQI(CVUI(CVCU(reg)),zero) "\tandi. \tr0,r%0,0xff\n\tbeq \t%a\n" 2
stmt: NEI(CVUI(CVCU(reg)),zero) "\tandi. \tr0,r%0,0xff\n\tbne \t%a\n" 2

stmt: EQI(ADDI(reg,reg),zero) "\tadd. \tr0,r%0,r%1\n\tbeq \t%a\n" 2
stmt: GEI(ADDI(reg,reg),zero) "\tadd. \tr0,r%0,r%1\n\tbge \t%a\n" 2
stmt: GTI(ADDI(reg,reg),zero) "\tadd. \tr0,r%0,r%1\n\tbgt \t%a\n" 2
stmt: LEI(ADDI(reg,reg),zero) "\tadd. \tr0,r%0,r%1\n\tble \t%a\n" 2
stmt: LTI(ADDI(reg,reg),zero) "\tadd. \tr0,r%0,r%1\n\tblt \t%a\n" 2
stmt: NEI(ADDI(reg,reg),zero) "\tadd. \tr0,r%0,r%1\n\tbne \t%a\n" 2


stmt: EQD(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tbeq \t%a\n" 2
stmt: EQF(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tbeq \t%a\n" 2
stmt: LED(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tble \t%a\n" 2
stmt: LEF(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tble \t%a\n" 2
stmt: LTD(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tblt \t%a\n" 2
stmt: LTF(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tblt \t%a\n" 2
stmt: GED(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tbge \t%a\n" 2
stmt: GEF(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tbge \t%a\n" 2
stmt: GTD(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tbgt \t%a\n" 2
stmt: GTF(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tbgt \t%a\n" 2
stmt: NED(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tbne \t%a\n" 2
stmt: NEF(reg,reg)  "\tfcmpo \tCR0, f%0,f%1\n\tbne \t%a\n" 2

stmt: JUMPV(reg)  "\tmtspr \tLR,r%0\n\tbclr  \t0x14,0x0\n"  2
reg:  CALLD(reg)  "# double call thru pointer\n" 5
reg:  CALLF(reg)  "# float call thru pointer\n" 5
reg:  CALLI(reg)  "# int call thru pointer\n" 5
stmt: CALLV(reg)  "# void call thru pointer\n" 5

ar:  ADDRGP "%a"
ar:  CNSTP  "%a"   range(a, 0, 0x0fffffff)
stmt: JUMPV(ar)  "\tb \t%0\n"   1
reg:  CALLD(ar)  "\tbl \t.%0\n\tcror \t31,31,31\n"  2
reg:  CALLF(ar)  "\tbl \t.%0\n\tcror \t31,31,31\n"  2
reg:  CALLI(ar)  "\tbl \t.%0\n\tcror \t31,31,31\n"  2
stmt: CALLV(ar)  "\tbl \t.%0\n\tcror \t31,31,31\n"  2

stmt: LABELV  "%a:\n"

stmt: RETD(reg)  "# ret\n"  1
stmt: RETF(reg)  "# ret\n"  1
stmt: RETI(reg)  "# ret\n"  1
stmt: ARGD(reg)  "# arg\n"  1
stmt: ARGF(reg)  "# arg\n"  1
stmt: ARGI(reg)  "# arg\n"  1
stmt: ARGP(reg)  "# arg\n"  1

stmt: ARGB(INDIRB(reg))       "# argb %0\n"      1
stmt: ASGNB(reg,INDIRB(reg))  "# asgnb %0 %1\n"  1
%%

/*---------------------------------------------------------------------------*/
static void progbeg(int argc, char *argv[]) 
{
  int i;

  {
    union {
      char c;
      int i;
    } u;
    u.i = 0;
    u.c = 1;
    swap = (u.i == 1) != IR->little_endian;
  }
  parseflags(argc, argv);
  for (i = 0; i < argc; i++) {
    if (strncmp(argv[i], "-G", 2) == 0)
      gnum = atoi(argv[i] + 2);
    if( strcmp(argv[i], "-S") == 0 )
      pretty_print = 1;
  }
  for (i = 0; i < 32; i ++)
    freg2[i] = mkreg("%d", i, 1, FREG);
  for (i = 0; i < 32; i++)
    ireg[i] = mkreg("%d", i, 1, IREG);
  ireg[1]->x.name = "SP";
  rmap[C] = rmap[S] = rmap[P] = rmap[B] = rmap[U] = rmap[I] =
    mkwildcard(ireg);
  rmap[F] = rmap[D] = mkwildcard(freg2);
  tmask[IREG] = INTTMP; tmask[FREG] = FLTTMP;
  vmask[IREG] = INTVAR; vmask[FREG] = FLTVAR;

  /* Dump out some ".set"s so that the assembly looks more readable */
  print("\
.set r0,0;   .set SP,1;   .set r1,1;   .set RTOC,2; .set r2,2;   .set r3,3\n\
.set r4,4;   .set r5,5;   .set r6,6;   .set r7,7;   .set r8,8;   .set r9,9\n\
.set r10,10; .set r11,11; .set r12,12; .set r13,13; .set r14,14; .set r15,15\n\
.set r16,16; .set r17,17; .set r18,18; .set r19,19; .set r20,20; .set r21,21\n\
.set r22,22; .set r23,23; .set r24,24; .set r25,25; .set r26,26; .set r27,27\n\
.set r28,28; .set r29,29; .set r30,30; .set r31,31\n\
.set f0,0;   .set f1,1;   .set f2,2;   .set f3,3;   .set f4,4;   .set f5,5\n\
.set f6,6;   .set f7,7;   .set f8,8;   .set f9,9;   .set f10,10; .set f11,11\n\
.set f12,12; .set f13,13; .set f14,14; .set f15,15; .set f16,16; .set f17,17\n\
.set f18,18; .set f19,19; .set f20,20; .set f21,21; .set f22,22; .set f23,23\n\
.set f24,24; .set f25,25; .set f26,26; .set f27,27; .set f28,28; .set f29,29\n\
.set f30,30; .set f31,31; .set FP,31\n\
.set CR0,0; .set MQ,0; .set XER,1; .set LR,8; .set CTR,9\n\
");

}

static int cvid_hack = 0;
static void progend()
{
  /* Convert INT to DOUBLE needs a special constant */
  if( cvid_hack ) {
    swtoseg(TOC_SEG);
    print("_toc_.i2d:\t.tc\tFD.433000008000000[tc],0x43300000,0x80000000\n");
  }
}

/*---------------------------------------------------------------------------*/
static void comment VARARGS(( char *fmt, ... ),
			    (fmt, va_alist),char *fmt; va_dcl)
{
  if( !pretty_print ) *bp++ = '\n';
  else {
    va_list ap;
    va_init(ap, fmt);
    vprint(fmt, ap);
    va_end(ap);
  }
}

/*---------------------------------------------------------------------------*/
static void target(Node p)
{
  assert(p);
  switch (p->op) {
  case CALLD: 
  case CALLF:  
    setreg(p, freg2[1]);      
    break;
  case CALLI:
  case CALLV:
    setreg(p, ireg[3]);
    break;
  case RETD: 
  case RETF:    
    rtarget(p, 0, freg2[1]);  
    p->kids[0]->x.registered=1;
    break;
  case RETI: 
    rtarget(p, 0, ireg[3]);  
    p->kids[0]->x.registered=1;
    break;
  case ARGI: case ARGP: 
    /* If the argument lands in the first 24 bytes of the argument area, then
       it can go in a register and it's not actually stored in the arg area. */
    if( p->syms[2]->u.c.v.i < 32 ) /* If arg falls in first 8 words */
      rtarget(p, 0, ireg[3+(p->syms[2]->u.c.v.i>>2)]);
    break;
  case ARGD: case ARGF: 
    /* The first 13 float values are passed in registers f1-f13 in all cases.
       Anything past 8 words also goes in the arg area.  Sometimes things less
       than 8 words also go in the GPRs! */
    if( p->x.argno < 13 ) 
      rtarget(p, 0, freg2[1+p->x.argno]);
    break;
  }
}

/*---------------------------------------------------------------------------*/
static void clobber(Node p) 
{
  assert(p);
  switch (p->op) {
  case CALLD: case CALLF:
    spill(0x00001ff9, IREG, p);	/* Spill volatile+int return regs */
    spill(0x00003fe1, FREG, p); /* Spill volatile regs */
    break;
  case CALLI:
    spill(0x00001fe1, IREG, p);	/* Spill volatile regs */
    spill(0x00003fff, FREG, p); /* Spill volatile+float return regs */
    break;
  case CALLV:
    spill(0x00001ff9, IREG, p);	/* Spill volatile+int return regs */
    spill(0x00003fff, FREG, p); /* Spill volatile+float return regs */
    break;
  case CVID:
    spill(0x00000001, IREG, p); /* Ugly code needs gpr0 */
    spill(0x00000001, FREG, p); /* Ugly code needs fpr0 */
    break;
  case CVDI:
    spill(0x00000001, FREG, p); /* Ugly code needs fpr0 */
    break;
  }
}

/*---------------------------------------------------------------------------*/
/* Return true if ARGument node P is being passed to a function with no
   prototype, or a variadic function. */
static int is_varargs_called(Node p)
{
  Type ty;
  while( generic(p->op) != CALL ) p = p->x.next;
  ty = p->kids[0]->syms[0]->type;
  return ty->u.f.oldstyle || variadic(ty);
}

/*---------------------------------------------------------------------------*/
static void emit2(Node p)
{
  switch (p->op) {
    /* PPC passing conventions.  Yuch.
       If any value is beyond 8 words, it must be stored to the argument area.
       Any value before 8 words is _never_ stored to the arg area.  These early
       parameters are targeted into registers by target() above.  Early floats
       and doubles with no prototype or a varargs prototype are ALSO passed in
       the integer registers! */
  case ARGI: case ARGP: {
    int offset = p->syms[2]->u.c.v.i;
    if( offset >= 32 ) {	/* Must go to argument save area? */
      print("\tstw \tr%d,24+%d(SP)", getregnum(p->x.kids[0]), offset);
      comment("\t\t# Save arg\n");
    } else			/* Nope, its been register targeted */
      comment("\t# argument in r%d\n", 3+(offset>>2));
    break;
  }
  case ARGD: {
    int offset = p->syms[2]->u.c.v.i;
    if( offset >= 32 ) {	/* Must go to argument save area? */
      if( p->x.argno < 13 ) 	/* Register targeted? */
	print("\tstfd \tf%d,24+%d(SP)", 1+p->x.argno,offset);
      else			/* Not register targeted */
	print("\tstfd \tf%d,24+%d(SP)", getregnum(p->x.kids[0]),offset);
      comment("\t\t# Save arg\n");
    } else {
      comment("\t# argument in f%d\n",1+p->x.argno);
      if(is_varargs_called(p)) {
	print("\tstfd \tf%d,-8(SP)",1+p->x.argno);
	comment("\t\t# Also passed in GPRs\n");
	print("\tlwz \tr%d,-8(SP)\n", 3+(offset>>2)  );
	print("\tlwz \tr%d,-4(SP)\n", 3+(offset>>2)+1);
      }
    }
    break;
  }
  case ARGF: {
    int offset = p->syms[2]->u.c.v.i;
    if( offset >= 32 ) {	/* Must go to argument save area? */
      if( p->x.argno < 13 )	/* Register targeted? */
	print("\tstfs \tf%d,24+%d(SP)",1+p->x.argno,offset);
      else			/* Not register targeted */
	print("\tstfs \tf%d,24+%d(SP)",
	      getregnum(p->x.kids[0]),offset);
      comment("\t# Save arg\n");
    } else {
      comment("\t# argument in f%d\n",1+p->x.argno);
      if(is_varargs_called(p)) {
	print("\tstfs \tf%d,-4(SP)", 1+p->x.argno);
	comment("\t\t# Also passed in GPRs\n");
	print("\tlwz \tr%d,-4(SP)\n", 3+(offset>>2));
      }
    }
    break;
  }
  case ARGB: {
    int offset = p->syms[2]->u.c.v.i;
    int size = roundup(p->syms[0]->u.c.v.i,4);
    int start = 0;
    int src = getregnum(p->x.kids[0]);
    while( offset < 32 && size ) {
      print("\tlwz \tr%d,%d(r%d)\n", 3+(offset>>2), start, src);
      start += 4;
      offset += 4;
      size -= 4;
    }
    if( size ) {
      /* Block copy the rest to the stack frame */
      dalign = 4;
      salign = p->syms[1]->u.c.v.i;
      blkcopy(1/* Stack pointer*/, 24+offset, src, start, size, tmpregs);
    }
    break;
  }

  case ASGNB:
    dalign = salign = p->syms[1]->u.c.v.i;
    blkcopy(getregnum(p->x.kids[0]), 0,
	    getregnum(p->x.kids[1]), 0,
	    p->syms[0]->u.c.v.i, tmpregs);
    break;
  case ADDRGP: {
    /* TOC handling done here.  There's a load required, and an optional off */
    Symbol s = p->syms[0];
    int reg = getregnum(p);
    int off = s->x.offset;
    s->addressed = 1;		/* It's addressed */
    print("\tlwz \tr%d,_toc_%s(RTOC)", reg, s->x.name);
    comment("\t# Load address of %s\n", s->x.name);
    if( off ) {
      if( off < 32768 ) {		/* Small offset? */
	print("\taddi \tr%d,r%d,%d", reg, reg, off );
	comment("\t\t# Offset from global\n");
      } else {			/* Humungous offset */
	print("\taddis \tr%d,r%d,(%d-((%d<16)>16))>16\n", reg, reg, off, off);
	print("\taddi \tr%d,r%d,(%d<16)>16", reg, reg, off);
	comment("\t# Big offset %d\n", off);
      }
    }
    break;
  }
  case CVID: {
    int src = getregnum(p->x.kids[0]);
    int dst = getregnum(p);
    /* Clobber above saves us fpr0 for our use */
    assert( dst != 0 );
    cvid_hack = 1;		/* We had a CVID, we need the constant */
    print("\txoris \tr0,r%d,0x8000", src);
    comment("\t\t# Flip sign bit\n");
    print("\tstw   \tr0,-4(SP)");
    comment("\t\t# Store in stack scratch\n");
    print("\taddis \tr0,r0,0x4330");
    comment("\t\t# Exponent bits\n");
    print("\tstw   \tr0,-8(SP)");
    comment("\t\t# Store in stack scratch\n");
    print("\tlfd   \tf%d,_toc_.i2d(RTOC)",dst);
    comment("\t# Load majik constant\n");
    print("\tlfd   \tf0,-8(SP)");
    comment("\t\t# Load hacked int bits\n");
    print("\tfsub  \tf%d,f0,f%d", dst, dst);
    comment("\t\t# Complete int->double conversion\n");
    break;
  }
  case CVDI: {
    int src = getregnum(p->x.kids[0]);
    int dst = getregnum(p);
    /* Clobber above saves us fpr0 for our use */
    assert( dst != 0 );
    print("\tfctiwz \tf0,f%d",src);
    comment("\t\t# Double->int conversion into f0\n");
    print("\tstfd \tf0,-8(SP)");
    comment("\t\t# Save bits to memory\n");
    print("\tlwz \tr%d,-4(SP)",dst);
    comment("\t\t# Load bits\n");
    break;
  }

  case CALLD:  case CALLF:  case CALLI:  case CALLV: {
    int src = getregnum(p->x.kids[0]);
    print("\tlwz \tr11,0(r%d)", src);  comment("\t\t# Load fcn ptr to r11\n");
    print("\tstw \tRTOC,20(SP)");      comment("\t\t# Save TOC\n");
    print("\tlwz \tRTOC,4(r%d)", src); comment("\t\t# Load new TOC\n");
    print("\tmtspr \tCTR,r11");      comment("\t\t\t# Fcn ptr to CTR\n");
    print("\tbcctrl \t0x14,0x1e");     comment("\t\t# branch/link\n");
    print("\tlwz \tRTOC,20(SP)");      comment("\t\t# Restore TOC\n");
    break;
  }

  }
}


/*---------------------------------------------------------------------------*/
static void doarg(Node p)
{
  static int f_argno;		/* Float-only argument counts */
  int ty = optype(p->op);	/* Type of argument */

  if (argoffset == 0)		/* New call? */
    f_argno = 0;		/* Reset arg count */
  if( ty == F || ty == D )	/* Float argument? */
    p->x.argno = f_argno++;	/* Then bump count of 'em */
  else p->x.argno = -99;	/* Trash value to trip me up */
  /* Here we bump the argoffset: offset into argument area. 
     Things less than a whole word round up to a word.
     Structures, doubles & etc all take their entire size. 
     Align is always WORD, even for doubles. */
  p->syms[2] = intconst(mkactual(4, roundup(p->syms[0]->u.c.v.i,4)));
}

/*---------------------------------------------------------------------------*/
static void local(Symbol p)
{
  /* Because we got lotsa registers, through everything into registers */
  if( isscalar(p->type) && !p->addressed && p->ref >= 2.0 )
    p->sclass = REGISTER;
  /* if( glevel ) p->sclass = AUTO; No register variables whilst debugging */
  if (askregvar(p, rmap[ttob(p->type)]) == 0)
    mkauto(p);
}


/*---------------------------------------------------------------------------*/
static Symbol curr_func;
static void function(Symbol f, Symbol caller[], Symbol callee[], int ncalls)
{
  int i;			/* Tmp counter */
  int varargs;			/* Flag for varargs routine or not */
  int sizeisave, sizefsave;	/* Size of GPR and FPR save areas */
  int sizesave;			/* Offset from FP */
  int in_fparms = 0;		/* Count of incoming float args */
  int in_argoffset = 24;	/* Incoming argument offset, 24+framesize */
  int argreg[8];		/* Source register for incoming args */
  const char *FN = f->x.name;	/* Easy access */

  curr_func = f;
  usedmask[0] = usedmask[1] = 0;
  freemask[0] = freemask[1] = ~(unsigned)0;
  for (i = 0; callee[i]; i++)
    ;
  varargs = variadic(f->type)
    || i > 0 && strcmp(callee[i-1]->name, "va_alist") == 0;
  for( i=0; i<32; i++ )
    ireg[i]->x.regnode->vbl = freg2[i]->x.regnode->vbl = NULL;

  for (i = 0; callee[i]; i++) {	/* For all parameters */
    Symbol p = callee[i];
    Symbol q = caller[i];
    Symbol reg=NULL;		/* Assume not in a register */
    int size = roundup(q->type->size, 4);
    p->x.offset = q->x.offset = in_argoffset;
    p->x.name = q->x.name = stringd(in_argoffset);

    /* Figure out how the danged thing got passed */
    if( isfloat(q->type) )  	/* First 13 floats in float regs */
      reg = (in_fparms++ < 13) ? freg2[in_fparms] : NULL;
    else 			/* First 8 words in GPRs */
      reg = (in_argoffset-24 < 4*8) ? ireg[((in_argoffset-24)>>2)+3] : NULL;
    if( reg ) argreg[i] = reg->x.regnode->number;

    /* Can't handle address'd parameters in a register.
       Worse, STABs can't handle parameters in registers either.  Sigh. */
    if( !p->addressed && !glevel ) {
      /* Figure out if it's in a register and can stay there */
      if( reg && !ncalls && !isstruct(q->type) ) {
	p->sclass = q->sclass = REGISTER;	/* It can stay */
	askregvar(p, reg);	/* Get the register */
	assert( p->x.regnode && p->x.regnode->vbl == p );
	q->x = p->x;		/* Copy the register field */
	q->type = p->type;
	/* Try to register-allocate in a non-parameter register */
      } else if( askregvar(p, rmap[ttob(p->type)]) && reg && 
		 (isint(p->type) || p->type == q->type) ) {
	assert( q->sclass != REGISTER );
	p->sclass = q->sclass = REGISTER;
	q->type = p->type;
      }
    }
    in_argoffset += size;	/* Bump incoming arg stack offset */
  }
  assert(caller[i] == 0);

  offset = maxoffset = 0;	/* No locals reserved yet */
  maxargoffset = 32;		/* Reserve space for at least 8 outgoing args*/

  /* Boilerplate the function start */
  swtoseg(TOC_SEG);
  print("_toc_%s:\n",FN);
  print("\t.tc\t%s{TC},%s{DS}\n",FN,FN);
  print("\t.csect \t%s{DS}\n",FN);
  print("\t.long \t.%s, TOC{TC0}, 0\n", FN);
  swtoseg(CODE);
  print(".%s:\n", FN);
  if( glevel ) {
    print("\t.function\t.%s,.%s,16,36,FE..%s-.%s\n",FN,FN,FN,FN);
    /* Replace the location of where the function declaration starts with
       the location of where the declaration _ends_, i.e., the open curly
       brace location. */
    f->src = codehead.next->u.point.src;
    print("\t.bf\t%d\n",f->src.y);
  }

  framesize = 0;		/* Flag that we ain't got framesize yet */
  gencode(caller, callee);	/* Make code, count locals & outgoing args */

  /* Word-align local variables */
  maxoffset = roundup(maxoffset,4); 
  /* Word-align outgoing argument area size */
  maxargoffset = roundup(maxargoffset,4); 
  /* Routine must save non-volatile registers only */
  usedmask[IREG] &= 0xffffe000; /* Save GPRs 13-31 */
  usedmask[FREG] &= 0xffffc000;	/* Save FPRs 14-31 */
  usedmask[IREG] |= 0x80000000;	/* FP (GPR 31) is used all the time */
  /* Count size of non-volatile register save areas */
  sizeisave = 4*(32-ff1(usedmask[IREG]));
  sizefsave = 8*(32-ff1(usedmask[FREG]));
  /* Frame is FPR save + GPR save + locals + outgoing args + 24, quadword */
  framesize = roundup(sizefsave+sizeisave + maxoffset + maxargoffset + 24,16);
  /* Sizesave is distance from old SP to the new FP: at end of locals */
  sizesave = framesize - 24 - maxargoffset - maxoffset;
  /* Now emit stabs for parameters, AFTER we know the framesize */
  if (glevel && IR->stabsym) {
    int i;
    Symbol p, q;
    for(i = 0; (p = callee[i]) != NULL && (q = caller[i]) != NULL; i++) {
      (*IR->stabsym)(p);
      if (p->sclass != q->sclass || p->type != q->type)
	(*IR->stabsym)(q);
    }
    swtoseg(CODE);
  }

  print("\tmfspr \tr0,LR");
  comment("\t\t\t# Return address to r0\n");

  /* Save non-volatile FPRs */
  for (i = 31; i >= 14; i-- )
    if( (usedmask[FREG] >> i) & 1 ) {
      print("\tstfd \tf%d,%d(SP)", i, -(32-i)*8);
      comment("\t\t# Save non-volatile f%d\n", i);
    }

  /* Save non-volatile GPRs */
  for (i = 31; i >= 13; i-- )
    if( !((usedmask[IREG] >> i) & 1) ) 
      break;
  if( i == 30 ) {
    print("\tstw \tr%d,%d(SP)", i+1, -(32-i-1)*4-sizefsave);
    comment("\t\t# Save non-volatile r%d\n", i+1);
  } else {
    print("\tstmw \tr%d,%d(SP)", i+1, -(32-i-1)*4-sizefsave);
    comment("\t\t# Save non-volatile r%d - r%d\n", i+1, 31);    
  }
  for ( ; i >= 13; i-- )
    if( (usedmask[IREG] >> i) & 1 ) {
      print("\tstw \tr%d,%d(SP)", i, -(32-i)*4-sizefsave);
      comment("\t\t# Save non-volatile r%d\n", i);
    }

  /* Now save off any args passed in registers, but needed in memory */
  for (i = 0; callee[i]; i++) {	/* For all parameters */
    Symbol p = callee[i];
    Symbol q = caller[i];	/* Get where we came from */
    int reg = argreg[i];
    assert( p->sclass != REGISTER || p->x.regnode );
    if( p->x.offset-24 >= 32 )	/* Passed the not-already-in-memory area? */
      break;			/* Then quit saving stuff */
    if( p->sclass == AUTO ) {	/* Needed on the stack? */
      if( isfloat(q->type) ) {
	print("\tstfd \tf%d,%d(SP)", reg, p->x.offset);
	comment("\t\t# Parm %d addressed or used, save f%d\n", i, reg);
      } else if( isscalar(q->type) ) {
	print("\tstw \tr%d,%d(SP)", reg, p->x.offset);
	comment("\t\t# Parm %d addressed or used, save r%d\n", i, reg);
      } else {
	int off = p->x.offset;
	int size = roundup(p->type->size, 4);
	assert( isstruct(q->type) );
	for( ; off-24 < 32 && size; size -= 4, off += 4 ) {
	  print("\tstw \tr%d,%d(SP)", reg++, off, i);
	  comment("\t\t# Structure moved to stack\n");
	}
      }
      /* Here I have passed an arg in a register, but must use it in another */
    } else if( p->x.regnode != q->x.regnode ) {
      if( isfloat(q->type) ) {
	print("\tfmr \tf%d,f%d", p->x.regnode->number, reg );
	comment("\t\t\t# Parm %d used in register f%d\n",
		i, p->x.regnode->number);
      } else {
	print("\tmr  \tr%d,r%d", p->x.regnode->number, reg );
	comment("\t\t\t# Parm %d used in register r%d\n", 
		i, p->x.regnode->number);
      }
    }
  }

  /* For varargs, we gotta save the remaining GPR area. 
     Leading named (not-varargs) arguments don't need to be saved. */
  if( varargs && !callee[i] ) {	/* Varargs and all named arguments handled? */
    i = callee[i-1]->x.offset + 
      roundup(callee[i-1]->type->size,4); /* End of last named arg*/
    for( ; i-24 < 32; i += 4 ) {
      int reg = ((i-24)>>2)+3;
      print("\tstw \tr%d,%d(SP)", reg, i);
      comment("\t\t# Save varargs r%d\n", reg);
    }
  }

  print("\tstw \tr0,8(SP)");  comment("\t\t# Save return address\n");
  print("\taddi \tFP,SP,%d",-sizesave); comment("\t\t# Set FramePointer\n");
  {
    /* Adjust all formal offsets by the sizesave area. */
    /* Formals are now directly referenced from the FP. */
    Code cp = codehead.next;
    for (i = 0; callee[i]; i++) {	/* For all parameters */
      Symbol p = callee[i];
      p->x.offset += sizesave;
      if( p->sclass == AUTO )
	p->x.name = stringd(p->x.offset);
      p = caller[i];
      p->x.offset += sizesave;
      if( p->sclass == AUTO )
	p->x.name = stringd(p->x.offset);
    }
    for ( ; cp; cp = cp->next)
      if( cp->kind == Address) {
	Symbol p = cp->u.addr.sym;
	if( p->scope == PARAM ) {
	  assert( p->sclass == AUTO );
	  p->x.offset += sizesave;
	  p->x.name = stringd(p->x.offset);
	}
      }
  }


  if( framesize ) {		/* Stack frame creation */
    if( framesize < 32768 ) {	/* Small frame? */
      print("\tstwu \tSP,-%d(SP)", framesize);
      comment("\t\t# Stack frame = %d(FPRs)+%d(GPRs)+%d(pad)+%d(locals)+%d(args)+24\n", sizefsave, sizeisave, sizesave-(sizefsave+sizeisave), maxoffset, maxargoffset);
    } else {			/* Humungous frame */
      print("\taddis \tr12,r0,((-%d)>16)&0xffff", framesize);
      comment("\t# Large frame size\n");
      print("\tori \tr12,r12,(-%d)&0xffff", framesize);
      comment("\t# Frame = %d(FPRs)+%d(GPRs)+%d(pad)+%d(locals)+%d(args)+24\n", sizefsave, sizeisave, sizesave-(sizefsave+sizeisave), maxoffset, maxargoffset);
      print("\tstwux \tSP,SP,r12");
      comment("\t\t# Atomically create stack frame\n");
    }
  }

  emitcode();

  print("\tlwz \tr0,%d(FP)",sizesave+8);
  comment("\t\t# Load return address\n");
  if( framesize ) {		/* Stack frame release */
    print("\taddi \tSP,FP,%d",sizesave); 
    comment("\t\t# Restore SP from FP\n");
  }

  /* Reload non-volatile GPRs */
  for (i = 31; i >= 13; i-- )
    if( !((usedmask[IREG] >> i) & 1) ) 
      break;
  if( i == 30 ) {
    print("\tlwz \tr%d,%d(SP)", i+1, -(32-i-1)*4-sizefsave);
    comment("\t\t# Load non-volatile r%d\n", i+1);
  } else {
    print("\tlmw \tr%d,%d(SP)", i+1, -(32-i-1)*4-sizefsave);
    comment("\t\t# Load non-volatile r%d - r%d\n", i+1, 31);    
  }
  for ( ; i >= 13; i-- )
    if( (usedmask[IREG] >> i) & 1 ) {
      print("\tlwz \tr%d,%d(SP)", i, -(32-i)*4-sizefsave);
      comment("\t\t# Load non-volatile r%d\n", i);
    }

  print("\tmtspr \tLR, r0");
  comment("\t\t\t# Return address to link register\n");

  /* Reload non-volatile FPRs */
  for (i = 31; i >= 14; i-- )
    if( (usedmask[FREG] >> i) & 1 ) {
      print("\tlfd \tf%d,%d(SP)", i, -(32-i)*8);
      comment("\t\t# Load non-volatile f%d\n", i);
    }

  if( glevel ) {
    print("\t.ef\t%d",src.y);
    comment("\t\t\t# End function %s\n", FN);
  }
  print("\tbclr \t0x14, 0x0\n");
  print("FE..%s:", FN);
  comment("\t\t\t\t# end %s\n\n\n", FN);
}

/*---------------------------------------------------------------------------*/
static void defconst(int ty, Value v) 
{
  switch (ty) {
  case C: print("\t.byte\t%d\n"  , v.uc); return;
  case S: print("\t.short\t%d\n" , v.ss); return;
  case I: print("\t.long\t0x%x\n", v.i ); return;
  case U: print("\t.long\t0x%x\n", v.u ); return;
  case P: print("\t.long\t0x%x\n", v.p ); return;
  case F: print("\t.long\t0x%x\n", *(unsigned *)&v.f);  return;
  case D: {
    unsigned *p = (unsigned *)&v.d;
    print("\t.long\t0x%x\n\t.long\t0x%x\n", p[swap], p[!swap]);
    return;
  }
  }
  assert(0);
}

/*---------------------------------------------------------------------------*/
static void defaddress(Symbol p)
{
  p->addressed = 1;
  print("\t.long\t%s%s+%d\n", p->x.name, 
	isfunc(p->type) ? "{ds}" : (p->sclass==EXTERN ? "{UA}" : ""),
	p->x.offset);
}

/*---------------------------------------------------------------------------*/
static void defstring(int n, char *str)
{
  int i;
  for( i=0; i<n-1; i++ )	/* Check all characters */
    if( str[i] < ' ' || str[i] == '"') /* Find an unpleasant character? */
      break;
  if( (i == n) && !str[n-1] )	/* All checked OK and nul-terminated? */
    print("\t.string\t\"%s\"\n", str); /* Nice method to print strings */
  else for( i=0; i<n; i++ )	/* Emit the hard way */
    print("\t.byte\t%d\n", str[i]);
}

/*---------------------------------------------------------------------------*/
static void export(Symbol p)
{
  if( isfunc(p->type) ) 
    print("\t.globl\t.%s\n\t.globl\t%s{ds}\n", p->x.name, p->x.name);
  else print("\t.globl\t%s\n", p->x.name);
}

/*---------------------------------------------------------------------------*/
static void import(Symbol p)
{
  if( p->ref == 0.0 ) return;
  if( isfunc( p->type ) ) {
    print("\t.extern\t.%s\n", p->name);
    if( !p->addressed ) return;
    swtoseg(TOC_SEG);
    print("_toc_%s:\n", p->x.name);
    print("\t.tc\t%s{TC},%s{ds}\n", p->x.name, p->x.name);
    print("\t.extern\t%s{ds}\n", p->name);
  } else {
    print("\t.extern\t%s{UA}\n", p->name);
    swtoseg(TOC_SEG);
    print("_toc_%s:\n", p->x.name);
    print("\t.tc\t%s{TC},%s{UA}\n", p->x.name, p->x.name);
  }
}

/*---------------------------------------------------------------------------*/
static void defsymbol(Symbol p)
{
  if (p->scope >= LOCAL && p->sclass == STATIC)
    p->x.name = stringf("L.%d", genlabel(1));
  else if (p->generated)
    p->x.name = stringf("L.%s", p->name);
  else {
    assert(p->scope != CONSTANTS || isint(p->type) || isptr(p->type));
    p->x.name = p->name;
  }
}

/*---------------------------------------------------------------------------*/
static void address(Symbol q, Symbol p, int n)
{
  q->x.offset = p->x.offset + n;
  if (p->scope == GLOBAL || p->sclass == STATIC || p->sclass == EXTERN)
    q->x.name = p->x.name;	/* Same name, different offset */
  else
    q->x.name = stringd(q->x.offset);
}

/*---------------------------------------------------------------------------*/
static void global(Symbol p)
{
  int oldseg = cseg;
  /* Slam in a TOC entry */
  swtoseg(TOC_SEG);
  print("_toc_%s:\n\t.tc\t%s{TC},%s\n",p->x.name,p->x.name,p->x.name);
  swtoseg(oldseg);
  if (p->u.seg == BSS) {
    if (p->sclass == STATIC || Aflag >= 2)
      print("\t.lcomm \t%s,%d,_.bss_c\n", p->x.name, p->type->size);
    else
      print( "\t.comm \t%s,%d\n", p->x.name, p->type->size);
  } else {
    if( p->type->align > 1 )	/* If greater-than-byte alignment needed */
      print("\t.align \t%c\n", ".01.2...3"[p->type->align]);
    print("%s:\n", p->x.name);
  }
}

/*---------------------------------------------------------------------------*/
static void space(int n) 
{
  if (cseg != BSS)
    print("\t.space \t%d\n", n);
}

/*---------------------------------------------------------------------------*/
static void segment(int n) 
{
  cseg = n;
  switch (n) {
  case CODE: print("\t.csect \t[pr]\n");  break;
  case DATA: print("\t.csect \t[rw]\n"); break;
  case LIT:  print("\t.csect \t[rw]\n"); break;
  case TOC_SEG: print("\t.toc\n"); break;
  }
}

/*---------------------------------------------------------------------------*/
static void blkloop(int dreg, int doff, int sreg, int soff, int size, int tmps[])
{
  int lab = genlabel(1);
  int rsz = size&~7;

  comment("\t# Block copy %d bytes from %d(r%d) to %d(r%d)\n",
	  size, soff, sreg, doff, dreg);
  if( (rsz) < 32768 ) {	/* Align to 8 byte size */
    print("\taddi \tr%d,r%d,%d", sreg, sreg, rsz);
    comment("\t\t# Add align(size,8) to src\n");
    print("\taddi \tr%d,r%d,%d", tmps[2], dreg, rsz);
    comment("\t\t# Set align(size,8)+dst in tmp r%d\n", tmps[2]);
  } else {
    print("\taddis \tr%d,r0,(%d-((%d<16)>16))>16\n", tmps[2], rsz, rsz);
    print("\taddi  \tr%d,r%d,(%d<16)>16\n", tmps[2], tmps[2], rsz);
    print("\tadd   \tr%d,r%d,r%d\n", sreg, tmps[2], sreg);
    print("\tadd   \tr%d,r%d,r%d\n", tmps[2], tmps[2], dreg);
  }
  blkcopy(tmps[2], doff, sreg, soff, size&7, tmps);
  print("L.%d:\n", lab);
  print("\taddi \tr%d,r%d,-8\n", sreg, sreg);
  print("\taddi \tr%d,r%d,-8\n", tmps[2], tmps[2]);
  blkcopy(tmps[2], doff, sreg, soff, 8, tmps);
  print("\tcmpl \tCR0,0,r%d,r%d\n", dreg, tmps[2]);
  print("\tblt \tL.%d\n", lab);
}

/*---------------------------------------------------------------------------*/
static void blkfetch(int size, int off, int reg, int tmp) 
{
  assert(size == 1 || size == 2 || size == 4);
  assert( salign >= size );
  if( size == 1 )
    print("\tlbz \tr%d,%d(r%d)\n", tmp, off, reg);
  else if( size == 2 )
    print("\tlhz \tr%d,%d(r%d)\n", tmp, off, reg);
  else
    print("\tlwz \tr%d,%d(r%d)\n", tmp, off, reg);
}

/*---------------------------------------------------------------------------*/
static void blkstore(int size, int off, int reg, int tmp) 
{
  assert(size == 1 || size == 2 || size == 4);
  assert( dalign >= size );
  if( size == 1 )
    print("\tstb \tr%d,%d(r%d)\n", tmp, off, reg);
  else if( size == 2 )
    print("\tsth \tr%d,%d(r%d)\n", tmp, off, reg);
  else
    print("\tstw \tr%d,%d(r%d)\n", tmp, off, reg);
}

/*---------------------------------------------------------------------------*/
/* Get the constant, return 0 or LBURG_MAX */
static int getcon( Node p, unsigned int *con ) 
{
  Symbol s = p->syms[0];
  unsigned int i;
  switch( p->op ) {
  case ADDRFP: 
  case ADDRLP: i = s->x.offset; break;
  case CNSTC:  i = s->u.c.v.sc; break;
  case CNSTI:  i = s->u.c.v.i;  break;
  case CNSTS:  i = s->u.c.v.ss; break;
  case CNSTU:  i = s->u.c.v.u;  break;
  case CNSTP:  i = (int)s->u.c.v.p;  break;
  default: return LBURG_MAX;
  }
  *con = i;
  return 0;
}

/*---------------------------------------------------------------------------*/
/* Return 0 if 16 low bits are zero, and LBURG_MAX otherwise. */
static int hibits( Node p ) 
{
  unsigned int i;
  if( getcon(p,&i) ) return LBURG_MAX;
  return (i & 0xffff) ? LBURG_MAX : 0;
}

/*---------------------------------------------------------------------------*/
/* Return 0 if the constant can be represented by a run of bits.  A bit run 
 * is a sequence of all 1'bits, with the remaining bits 0.  The sequence can 
 * wrap at the end of the word. */
static int bitrun( Node p )
{ 
  unsigned int i;
  int r, lsb, idx0, idx1;
  if( getcon(p,&i) ) return LBURG_MAX;
  
  /* A finite sequence of 1 bits has a start and a finish, i.e., one 0->1
   * changeup and one 1->0 changeup.  If we rotate the word right 1 and XOR
   * it, we'll get 1 bits at the changeups and 0s elsewhere.  We need to have
   * exactly 2 changeups.  */
  r = (i>>1) |			/* i logical shift right 1, not rotated */
    ((i<<31)&(1L<<31));		/* Or in the high order bit */
  r ^= i;			/* XOR 'em together */
  r -= lsb = (r & -r);		/* Compute LSB, or first change-up */
  if( r - (r & -r) ) return LBURG_MAX; /* More than 1 more bit */
  idx0 = ff1(lsb);		/* Index of LSB */
  idx1 = ff1(r);		/* Index of MSB */
  /* Record the start & end runs in x.argno */
  p->x.argno = ( lsb & i ) ? (idx0<<5) + idx1 : (idx1<<5) + idx0;
  return 0;			/* Only 2 changeups */
}

/*---------------------------------------------------------------------------*/
/* Check for bit field insert.  This is expressed as the OR of two AND'd
 * fields, where the AND's have complemented bit masks. 
 */
static int bins( Node p )
{ 
  Node and0 = p->kids[0];
  int s0 = and0->x.argno>>5;	/* Begin/end bitrun mask */
  int e0 = and0->x.argno&31;
  Node and1 = p->kids[1];
  int s1 = and1->x.argno>>5;	/* Begin/end bitrun mask */
  int e1 = and1->x.argno&31;
  p->x.argno = and1->x.argno;
  return ((s0-e1) | (s1-e0)) ? LBURG_MAX : 2;
}

/*---------------------------------------------------------------------------*/
/* Find first 1, or return 32 if empty */
static int ff1(unsigned mask)
{
  unsigned i, n = 0;

  for( i=1, n=0; i; i<<=1, n++)
    if( mask&i ) 
      return n;
  return 32;
}

/*---------------------------------------------------------------------------*/
#include <dbxstclass.h>

static char *currentfile;       /* current file name */
static int ntypes;

static void stabblock ARGS((int, int, Symbol*));
static void stabfend ARGS((Symbol, int));
static void stabinit ARGS((char *, int, char *[]));
static void stabline ARGS((Coordinate *));
static void stabsym ARGS((Symbol));
static void stabtype ARGS((Symbol));

static void asgncode ARGS((Type, int));
static void dbxout ARGS((Type));
static int dbxtype ARGS((Type));
static int emittype ARGS((Type, int, int));

/*---------------------------------------------------------------------------*/
/* asgncode - assign type code to ty */
static void asgncode(Type ty, int lev)
{
  if (ty->x.marked || ty->x.typeno)
    return;
  ty->x.marked = 1;
  switch( ty->op ) {
  case VOLATILE: case CONST: case VOLATILE+CONST:
    asgncode(ty->type, lev);
    ty->x.typeno = ty->type->x.typeno;
    break;
  case POINTER: case FUNCTION: case ARRAY:
    asgncode(ty->type, lev + 1);
    /* fall thru */
  case VOID: case CHAR: case SHORT: case INT: case UNSIGNED:
  case FLOAT: case DOUBLE:
    break;
  case STRUCT: case UNION: {
    Field p;
    for( p = fieldlist(ty); p; p = p->link )
      asgncode(p->type, lev + 1);
  }
  /* fall thru */
  case ENUM:
    if( ty->x.typeno == 0 )
      ty->x.typeno = ++ntypes;
    if( lev > 0 && (*ty->u.sym->name < '0' || *ty->u.sym->name > '9') )
      dbxout(ty);
    break;
  default:
    assert(0);
  }
}

/*---------------------------------------------------------------------------*/
/* dbxout - output .stabx entry for type ty */
static void dbxout(Type ty)
{
  ty = unqual(ty);
  if( !ty->x.printed ) {	/* Not already emitted? */
    int col = 0;		/* Start column counting */
    /* Print stabx and some tabs */
    print("\t.stabx \t\""), col += 17;
    /* If I have a symbol, and it's not a function, array or pointer */
    if( ty->u.sym && !(isfunc(ty) || isarray(ty) || isptr(ty)) )
      /* Then emit the user's type name */
      print("%s", ty->u.sym->name), col += strlen(ty->u.sym->name);
    /* Emit the "NamedType" type tag */
    print(":%c", isstruct(ty) || isenum(ty) ? 'T' : 't'), col += 2;
    /* Recursively dump the type */
    emittype(ty, 0, col);
    /* Emit symbol's value, storage class and type */
    print("\",0,%d,0\t# ", C_DECL);
    if( pretty_print ) outtype(ty);
    print("\n");
  }
}

/*---------------------------------------------------------------------------*/
/* dbxtype - emit a stabs entry for type ty, return type code */
static int dbxtype(Type ty)
{
  asgncode(ty, 0);
  dbxout(ty);
  return ty->x.typeno;
}

/*---------------------------------------------------------------------------*/
/* emittype - emit ty's type number, emitting its definition if necessary.
 * Returns the output column number after emission; col is the approximate
 * output column before emission and is used to emit continuation lines for 
 * long struct, union, and enum types.  Continuations are not emitted for other
 * types, even if the definition is long.  lev is the depth of calls to 
 * emittype.
 */
static int emittype(Type ty, int lev, int col)
{
  int tc = ty->x.typeno;

  /* Qualified types just copy the typeno and are done. */
  if( isconst(ty) || isvolatile(ty) ) {
    col = emittype(ty->type, lev, col);
    ty->x.typeno = ty->type->x.typeno;
    ty->x.printed = 1;
    return col;
  }
  if (tc == 0)			/* Not already got a typeno? */
    ty->x.typeno = tc = ++ntypes; /* Then get a new unique number */
  print("%d", tc), col += 3;
  if( ty->x.printed )		/* Printed already? */
    return col;			/* Then we are done! */
  ty->x.printed = 1;		/* It's printed now! */

  switch( ty->op ) {		/* Break out and print each type */
  case VOID:			/* Previous void def */
    print("=%d", TP_VOID), col += 1+3;
    break;
  case CHAR:			/* Previous char def */
    print("=%d", (ty == unsignedchar) ? TP_UCHAR : TP_CHAR), col += 1+3;
    break;
  case SHORT:			/* Previous short def */
    print("=%d", (ty == unsignedshort) ? TP_USHORT : TP_SHORT), col += 1+3;
    break;
  case INT:			/* Previous int def */
    print("=%d", TP_INT), col += 1+3;
    break;
  case UNSIGNED:		/* Previous unsigned def */
    print("=%d", TP_UNSIGNED), col += 1+3;
    break;
  case FLOAT: 
    print("=%d", TP_FLOAT), col += 1+3;
    break;
  case DOUBLE:	
    print("=%d", TP_DOUBLE), col += 1+3;
    break;
  case POINTER:
    print("=*"), col += 2;
    col = emittype(ty->type, lev + 1, col);
    break;
  case FUNCTION:
    print("=f"), col += 2;	/* Static function? */
    col = emittype(ty->type, lev + 1, col);
    break;
  case ARRAY:			/* array includes subscript as an int range */
    if( ty->size && ty->type->size )
      print("=ar%d;0;%d;", TP_INT, ty->size/ty->type->size - 1), col += 7+2+1;
    else
      print("=ar%d;0;-1;", TP_INT), col += 11;
    col = emittype(ty->type, lev + 1, col);
    break;
  case STRUCT: case UNION: {
    Field p;
    /* if( !ty->u.sym->defined ) {
      print("=x%c%s:", ty->op == STRUCT ? 's' : 'u', ty->u.sym->name);
      col += 2+1+strlen(ty->u.sym->name)+1;
      break;
    } */
    if (lev > 0 && (*ty->u.sym->name < '0' || *ty->u.sym->name > '9')) {
      ty->x.printed = 0;
      break;
    }
    print("=%c%d", ty->op == STRUCT ? 's' : 'u', ty->size), col += 1+1+3;
    for( p = fieldlist(ty); p; p = p->link ) {
      if (p->name)
	print("%s:", p->name), col += strlen(p->name)+1;
      else
	print(":"), col += 1;
      col = emittype(p->type, lev + 1, col);
      if( p->lsb )
	print(",%d,%d;", 8*p->offset +
	      (IR->little_endian ? fieldright(p) : fieldleft(p)),
	      fieldsize(p));
      else
	print(",%d,%d;", 8*p->offset, 8*p->type->size);
      col += 1+3+1+3+1;		/* accounts for ,%d,%d; */
      if( col >= 80 && p->link ) {
	print("?\",0,%d,0\n\t.stabx \t\"", C_DECL);
	col = 17;
      }
    }
    print(";"), col += 1;
    break;
  }
  case ENUM: {
    Symbol *p;
    if (lev > 0 && (*ty->u.sym->name < '0' || *ty->u.sym->name > '9')) {
      ty->x.printed = 0;
      break;
    }
    print("=e"), col += 2;
    for( p = ty->u.sym->u.idlist; *p; p++ ) {
      print("%s:%d,", (*p)->name, (*p)->u.value), col += strlen((*p)->name)+3;
      if (col >= 80 && p[1]) {
	print("?\",0,%d,0\n\t.stabx \t\"", C_DECL);
	col = 17;
      }
    }
    print(";"), col += 1;
    break;
  }
  default:
    assert(0);
  }
  return col;
}

/*---------------------------------------------------------------------------*/
/* stabblock - output a stab entry for '{' or '}' at level lev */
static void stabblock(int brace, int lev, Symbol *p)
{
  if( lev ) {
    print("\t.%cb \t%d", brace == '{' ? 'b' : 'e', src.y);
    comment("\t\t\t# Block depth %d\n", lev);
  }  
  if( brace == '{' )		/* Start of a block? */
    while (*p)			/* Then emit variable declarations */
      stabsym(*p++);
}

/*---------------------------------------------------------------------------*/
/* stabfend - end of function p */
static void stabfend(Symbol p, int line) 
{
}

/*---------------------------------------------------------------------------*/
/* stabinit - initialize stab output */
static void stabinit(char *file, int argc, char *argv[]) 
{
  typedef void (*Closure) ARGS((Symbol, void *));

  if( file && *file ) {
    (*IR->segment)(CODE);
    print("\t.file\t\"%s\"\n", file);
    currentfile = file;
  } else {
    currentfile = NULL;
  }
  dbxtype(inttype);
  dbxtype(chartype);
  dbxtype(doubletype);
  dbxtype(floattype);
  dbxtype(longdouble);
  dbxtype(longtype);
  dbxtype(shorttype);
  dbxtype(signedchar);
  dbxtype(unsignedchar);
  dbxtype(unsignedlong);
  dbxtype(unsignedshort);
  dbxtype(unsignedtype);
  dbxtype(voidtype);
  foreach(types, GLOBAL, (Closure)stabtype, NULL);
}

/*---------------------------------------------------------------------------*/
/* stabline - emit stab entry for source coordinate *cp */
static void stabline(Coordinate *cp)
{
  if( cp->file && cp->file != currentfile ) {
    print("\t.file\t\"%s\"\n", cp->file);
    currentfile = cp->file;
  }
  if( curr_func->src.file == currentfile ) {
    print("\t.line\t%d", cp->y - curr_func->src.y+1);
    comment("\t\t\t# Source line %d\n", cp->y+1);
  }
}

/*---------------------------------------------------------------------------*/
/* stabsym - output a stab entry for symbol p */
static void stabsym(Symbol p)
{
  int tc;
  Type ty = p->type;

  if( p->generated || p->computed )
    return;			/* Skip if internal variable */
  if( p->scope == PARAM && !framesize ) return;
  if( isfunc(ty) ) {		/* Print function declaration */
    print("\t.stabx \t\"%s:%c%d\",.%s,%d,0", p->name, 
	  p->sclass == STATIC ? 'f' : 'F', dbxtype(freturn(ty)), 
	  p->x.name, C_FUN);
    if( pretty_print ) {
      print("\t# %k ", p->sclass);
      outtype(ty);
    }
    print("\n");
    return;
  }

  if (!IR->wants_argb && p->scope == PARAM && p->structarg) {
    assert(isptr(ty) && isstruct(ty->type));
    ty = ty->type;		/* Structures passed by reference */
  }
  tc = dbxtype(ty);		/* Compute STABS TypeID for the type */

  if( p->sclass == AUTO && p->scope == GLOBAL || p->sclass == EXTERN ) {
    print(".stabx \"%s:G%d\",0,%d,0\t#", p->name, tc, C_GSYM);
  } else if( p->sclass == STATIC ) {
    if( p->u.seg == BSS ) print("\t.bs \t_.bss_c\n",p->src.file);
    else print("\t.bs \t[rw]\n");
    print("\t.stabx\t \"%s:%c%d\",0,%d,0\n", p->name, 
	  p->scope == GLOBAL ? 'S' : 'V', tc, 
	  p->u.seg == BSS ? C_LSYM : C_STSYM);
    print("\t.es\t# ");
  } else if( p->sclass == REGISTER ) {
    int r = p->x.regnode->number;
    if (p->x.regnode->set == FREG)
      r += 32;			/* floating point */
    print("\t.stabx\t \"%s:r%d\",%d,%d,0", p->name, tc, r, C_RSYM);
    if( pretty_print ) print("\t# r%d", r);
  } else if( p->scope == PARAM ) {
    assert( p->sclass != EXTERN );
    print("\t.stabx\t \"%s:p%d\",%s+%d,%d,0", 
	  p->name, tc, p->x.name, framesize, C_PSYM);
    if( pretty_print ) print("\t# param");
  } else if (p->scope >= LOCAL) {
    assert( p->sclass != EXTERN );
    print("\t.stabx\t \"%s:%d\",%d+24%s,%d,0", 
	  p->name, tc, maxargoffset+maxoffset, p->x.name, C_LSYM);
    if( pretty_print ) print("\t# local");
  } else
    assert(0);
  if( pretty_print ) {
    print(" %k ", p->sclass);
    outtype(ty);
    print(" %s", p->name);
  }
  print("\n");
}

/*---------------------------------------------------------------------------*/
/* stabtype - output a stab entry for type *p */
static void stabtype(Symbol p)
{
  if (p->type) {
    if (p->sclass == 0)
      dbxtype(p->type);
    else if (p->sclass == TYPEDEF) {
      print("\t.stabx \t\"%s:t%d\",0,%d,0\n", p->name,dbxtype(p->type),C_LSYM);
    }
  }
}

/*---------------------------------------------------------------------------*/
Interface ppcIR = {
  1, 1, 0,  /* char */
  2, 2, 0,  /* short */
  4, 4, 0,  /* int */
  4, 4, 1,  /* float */
  8, 4, 1,  /* double * MB */
  4, 4, 0,  /* T * */
  0, 1, 0,  /* struct */
  0,  /* little_endian */
  0,  /* mulops_calls */
  0,  /* wants_callb */
  1,  /* wants_argb */
  1,  /* left_to_right */
  0,  /* wants_dag */
  address,
  blockbeg,
  blockend,
  defaddress,
  defconst,
  defstring,
  defsymbol,
  emit,
  export,
  function,
  gen,
  global,
  import,
  local,
  progbeg,
  progend,
  segment,
  space,
  stabblock, 0, stabfend, stabinit, stabline, stabsym, stabtype,
  {
    1,  /* max_unaligned_load */
    blkfetch, blkstore, blkloop,
    _label,
    _rule,
    _nts,
    _kids,
    _opname,
    _arity,
    _string,
    _templates,
    _isinstruction,
    _ntname,
    emit2,
    doarg,
    target,
    clobber,

  }
};

